#include "ConvolvedCubeMapRenderTechnique.h"


ConvolvedCubeMapRenderTechnique::ConvolvedCubeMapRenderTechnique(unsigned long startFrame,
												unsigned long cubeMapUpdateInterval,
												unsigned int cubeMapResolution,												
												unsigned int reducedCubeMapResolution,
												bool useDistCalc,
												bool useFaceAngleCalc,
												float distTolerance,
												float angleTolerance,
												bool updateAllFace,
												bool renderSelf,
												bool renderEnvironment,
												ElementaryRenderable* parentRenderable,
												TechniqueGroup* parentTechniqueGroup)
												
												:CubeMapRenderTechnique( startFrame, cubeMapUpdateInterval, cubeMapResolution,
																					useDistCalc, useFaceAngleCalc, distTolerance, angleTolerance,
																					updateAllFace, renderSelf, renderEnvironment, 0,
																					parentRenderable, parentTechniqueGroup),
												RenderTechnique(parentRenderable, parentTechniqueGroup)
{
	cubemapLayer = ILLUMRUN_COLOR_CUBEMAP;
	this->reducedCubeMapResolution = reducedCubeMapResolution;
}

ConvolvedCubeMapRenderTechnique::~ConvolvedCubeMapRenderTechnique()
{

}

void ConvolvedCubeMapRenderTechnique::runChanged(RenderingRunType runType, RenderingRun* run)
{
	if(runType == ILLUMRUN_COLOR_CUBEMAP)
	{
		colorCubeMapRunChanged(run);
		return;
	}	
	if(runType == ILLUMRUN_REDUCED_CUBEMAP)
	{
		reducedCubeMapRunChanged(run);
		return;
	}
}

 void ConvolvedCubeMapRenderTechnique::update(unsigned long frameNum)
{	
		sharedRuns->updateRun(ILLUMRUN_COLOR_CUBEMAP, frameNum);	
		sharedRuns->updateRun(ILLUMRUN_REDUCED_CUBEMAP, frameNum);	
}
